<?php

declare(strict_types=1);

namespace App\Entity\Place;

use ApiPlatform\Metadata\ApiResource;
use App\Entity\Access\Access;
// use DH\Auditor\Provider\Doctrine\Auditing\Annotation\Auditable;
use App\Entity\Core\AbstractRepair;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @todo : A la suite de la migration, il faut supprimer le nom de la table pour avoir une table RoomRepair, et supprimer l'attribut discr.
 *
 * Réparation effectuée sur une salle (Room)
 */
// #[Auditable]
#[ApiResource(operations: [])]
#[ORM\Entity]
class RoomRepair extends AbstractRepair
{
    #[ORM\ManyToOne(inversedBy: 'repairs')]
    private ?Room $room = null;

    #[ORM\ManyToOne(inversedBy: 'roomRepairProviders')]
    #[ORM\JoinColumn(referencedColumnName: 'id', nullable: true, onDelete: 'SET NULL')]
    private ?Access $provider = null;

    public function __construct()
    {
        $this->tags = new ArrayCollection();
    }

    public function getRoom(): ?Room
    {
        return $this->room;
    }

    public function setRoom(?Room $room): self
    {
        $this->room = $room;

        return $this;
    }

    public function getProvider(): ?Access
    {
        return $this->provider;
    }

    public function setProvider(?Access $provider): self
    {
        $this->provider = $provider;

        return $this;
    }
}
